/*
* $Header: /home/dto/octal/RCS/commands.c,v 1.1 2000/07/19 08:00:06 dto Exp dto $
* (C) 2000 David O'Toole $Date: 2000/07/19 08:00:06 $
*
* COMMANDS.C 
* the basic ipc plumbing for octal's
* core and gui threads. 
*
* $Revision: 1.1 $
* This software is distributed under the terms of the
* GNU General Public License (GPL). Read the included file
* COPYING for more information. 
*
*/
static const char rcsid[]="$Id: commands.c,v 1.1 2000/07/19 08:00:06 dto Exp dto $";

#include <unistd.h> /* for pipes */
#include "commands.h"
#include "octal.h"

/* these are the file descriptors for the pipes
 * that carry commands between the core and gui
 */ 

int user_pipe[2]; /* messages from user */ 
int core_pipe[2]; /* messages from core */ 

/* the core writes to the core pipe, and 
 * reads from the user pipe. 
 */


int open_pipes(void)
{
  int x,y;

  x = pipe(user_pipe);
  y = pipe(core_pipe);
  
  if (x < 0 || y < 0)
    ox_die("open_pipes() failed.\n");
  else return 1; 
}

int close_pipes(void)
{
  close(user_pipe[0]);
  close(user_pipe[1]);
  close(core_pipe[0]);
  close(core_pipe[1]);
}




/* End $Source: /home/dto/octal/RCS/commands.c,v $*/

















