/*
* $Header: /home/dto/octal/RCS/engine_quux.h,v 1.1 2000/07/19 08:00:06 dto Exp dto $
* (C) 2000 David O'Toole $Date: 2000/07/19 08:00:06 $
* $Revision: 1.1 $
* 
* engine digraph analysis / compilation
* 
* This software is distributed under the terms of the
* GNU General Public License (GPL). Read the included file
* COPYING for more information. 
* 
*/

#ifndef _engine_quux_h_
#define _engine_quux_h_ "@(#)myfile.h $Revision: 1.1 $"

#include "engine.h"

/* quuxes
 *  
 * lists of engine_quuxes are like C strings. the opcode value "ex_terminate"
 * is the terminator.
 * 
 */ 

typedef struct _engine_quux {
  int opcode;
  int a, b; 
} engine_quux;

typedef struct _engine_program {
  engine_quux** quuxes;
  int num_quuxes;
  int max_quuxes; /* high-water mark */ 
} engine_program;

void ex_execute  (engine*,int,int);
void ex_add      (engine*,int,int);
void ex_remix    (engine*,int,int);
void ex_clear    (engine*,int,int);

enum {ex_execute_opcode, ex_add_opcode,
      ex_remix_opcode, ex_clear_opcode}; 

enum { ex_terminate_opcode = -1 };  /* used to mark end of program */

engine_quux* create_engine_quux(int opcode, int a, int b);
void append_quux(engine_program*, engine_quux*);
int execute_engine_quux(engine*, engine_quux*);
void compile_digraph(engine* e, int machine_index, engine_program*); 




#endif 

/* $Source: /home/dto/octal/RCS/engine_quux.h,v $ */
