/* $Header: /home/dto/octal/RCS/main.c,v 1.4 2000/02/23 04:30:39 dto
* Exp dto $ (C) 2000 David O'Toole $Date: 2000/06/23 06:10:33 $
* 
* MAIN.C
* 
* Once again this is just for testing... all will be replaced.
*
* $Revision: 1.12 $ 
*
* This software is distributed under the terms of the
* GNU General Public License (GPL). Read the included file
* COPYING for more information. 
*
*/

/* some temporary #defines */ 
#define TICK 44100
#define BLOCK (TICK/5)

#include <stdio.h>
#include "output.h"
#include "util.h"
#include "machine.h"
#include "engine.h"  /* soon this won't be here, moving to core */ 
#include "engine_quux.h"

static const char rcsid[]="$Id: main.c,v 1.12 2000/06/23 06:10:33 dto Exp dto $";

char melody[15][8] = { "g-4", 
		       "g-4", 
		       "g-4", 
		       "d-5", 
		       "d-5", 
		       "d-5", 
		       "c-5", 
		       "b-4", /* can you guess the song? */ 
		       "a-4", 
		       "g-5",  
		       "g-5", 
		       "g-5",  
		       "d-5", 
		       "d-5",  
		       "d-5", }; 


int main(int argc, char *argv[]) 
{
  engine_quux* q; 
  machine* square;
  machine* sq2; 
  machine* delay; 
  machine_type* t; 
  engine* e; 
  engine_program* ep; 
  pattern* p;
  int square_ix, delay_ix, sq2_ix; /* indexes */ 
  int i, j;
  int arg = 3; 
  /****************/

  printf("* This is OCTAL. \n------------\n");

  e = create_engine();

  init_freq_table();
  init_note_names();

  load_type_registry(".");  
  square = create_machine(get_type("dtosquare"));
  delay = create_machine(get_type("mdelay"));
  sq2 = create_machine(get_type("dtosquare"));

  square_ix = add_machine(e, square);
  delay_ix = add_machine(e, delay); 
  sq2_ix = add_machine(e, sq2); 

  printf("Created machines. %p %d %p %d \n", square, square_ix, delay, delay_ix);

  connect_machines(e, en_normal, delay_ix, 0);         /* to master */ 
  connect_machines(e, en_normal, square_ix, delay_ix); /* connect square to delay */ 
  connect_machines(e, en_normal, sq2_ix, delay_ix); 

  for (i=0; i<5; i++) {
    for (j=0; j<5; j++)
      printf("%d ", e->signals[i][j]);
    printf("\n");
  }

  t = get_type("dtosquare");
  p = create_pattern(t->num_params, 15);  

  printf("Attempting to compile digraph.\n");

  ep = create_engine_program();
  compile_digraph(e, 0, ep);

  for (j = 0; j < 15; j++)
    set_cell(p, 0, j, 0, pkg_text2note(melody[j]));
 
    for (i = 0; i < ep->num_quuxes; i++) {
      printf("quux #%d:", i);
      execute_engine_quux(e, ep->quuxes[i]);
    }
 
  destroy_machine(square);
  destroy_machine(delay);
  destroy_machine(sq2);
  destroy_engine_program(ep);
  destroy_pattern(p); 
  return(0);

}
	
/* End $Source: /home/dto/octal/RCS/main.c,v $ */
