/*
* $Header: /home/dto/octal/RCS/octal.h,v 1.6 2000/06/10 01:11:06 dto Exp $
* (C) 2000 David O'Toole $Date: 2000/06/10 01:11:06 $
* $Revision: 1.6 $
* 
* OCTAL. Definitions and macros for datatypes, etcetera. 
*
* This software is distributed under the terms of the
* GNU General Public License (GPL). Read the included file
* COPYING for more information. 
* 
* $Log: octal.h,v $
* Revision 1.6  2000/06/10 01:11:06  dto
* Minor changes to spelling of a macro.,
*
* Revision 1.5  2000/06/03 05:55:49  dto
* minor tweaks; changed "
* data" to "param"
*
* Revision 1.4  2000/03/28 07:17:39  dto
* Added utility function ox_die()
*
* Revision 1.3  2000/03/11 06:33:33  dto
* Conversion and partial rewrite done. Still working. It's 2 AM.
*
* Revision 1.2  2000/02/23 04:30:39  dto
* checkin before major incompatible changes.
* At the suggestion of Andy Sloane (andy@guildsoftware.com) I am switching over to a
* floating-point representation for all audio data stored in OCTAL. Some other changes will be made too;
* more info later.
*/

#ifndef _octal_h_
#define _octal_h_ "@(#)myfile.h $Revision: 1.6 $"

#define OX_SAMPLING_RATE (44100)
#define NUM_OCTAVES 9
#define NOTE_RANGE (NUM_OCTAVES*12)

typedef short data;  /* a signed integer used for storing all machine control data values */
typedef short param; /* ditto */ 
typedef float freq;  /* for frequency values                                              */
typedef float samp;  /* for audio data                                                    */

void ox_die(const char* message);

#endif /* _octal_h_ */

/* $Source: /home/dto/octal/RCS/octal.h,v $ */
