/*
* $Header: /home/dto/octal/RCS/pattern.h,v 1.6 2000/07/19 08:00:06 dto Exp dto $
* (C) 2000 David O'Toole $Date: 2000/07/19 08:00:06 $
* $Revision: 1.6 $
* 
* PATTERN.H 
* Definitions for OCTAL's pattern/event system. 
*
* This software is distributed under the terms of the
* GNU General Public License (GPL). Read the included file
* COPYING for more information. 
* 
*/
#ifndef _pattern_h_
#define _pattern_h_ "@(#)pattern.h $Revision: 1.6 $"

#include "octal.h"

enum {default_tracks = 16}; 

struct _pattern {
  int num_tracks; 
  int max_tracks; /* current high-water mark */ 
  int params_per_track; 
  int num_rows; 
  
  param **cells;   /* pointer to array of tracks */ 
}; 

typedef struct _pattern pattern; 

pattern* create_pattern(int params_per_track, int num_rows);
void destroy_pattern(pattern*); 

void add_track(pattern* p);   /* we always deal with the last one, for now */ 
void delete_track(pattern* p); 

void set_cell(pattern* p, int track, int row, int col, param value); 
param get_cell(pattern* p, int track, int row, int col); 

/* add a bridge function meant to read/update an entire row's worth of params */ 





#endif /*_pattern_h_*/
/* $Source: /home/dto/octal/RCS/pattern.h,v $ */
